/*
 * +-----------------------------------------------+
 * | System:                                       |
 * | Package:                                      |
 * | Class:    Comm                                |
 * +-----------------------------------------------+
 * | Author:   Michael Ransburg (Daneel)           |
 * |           <daneel@tux.org>                    |
 * | Created:  04.12.1999                          |
 * | Version:  0.0.1                               |
 * +-----------------------------------------------+
 *
 * Changes:
 *     04.12.1999 - (Daneel): - created :-)
 *
 */

import java.util.*;
import java.io.*;
import java.net.*;

public class Browse {

  public Browse(final String text, final String iptext, final String lengthtext, final String linktext) {
	Thread t = new Thread() {
	  public void run() {

		String response;
		String filename_short = new String();
		String responsestring = new String();
		int row = 0;

		
		GUI.status.changeStatus("Getting Files ... please wait");
		GUI.content.clearSearchContent();
  
		Main.comm.sendPacket(211, text);

		try {
		  java.lang.Thread.sleep(3000);
		}
		catch (InterruptedException ie) {
		  System.out.println(ie);
		}

//		Main.comm.recPacket(212, 11);

//		while (Main.comm.getMessid() != -10) {

		for ( ;; ) {
		
		  Main.comm.recPacket();

		  if (Main.comm.getMessid() == 213) { // 0 byte data section --> finished
			System.out.println("Got 0 byte packet --> search finished");
			break;
		  }

		  if (Main.comm.getMessid() != 212) { // read over status packages
			System.out.println("Got status packet --> read over it");
			continue;
		  }


		  response = Main.comm.getContent();

		  System.out.println("\n" + response + "\n");

		  StringTokenizer tokenizer = new StringTokenizer(response,"\"");
	  
		  if (tokenizer.countTokens() != 3) {
//			GUI.status.changeStatus("Got weird search result - aborting (if there are no results, just search again)");
//			return;
			System.out.println("Got broken package --> read over it");
			continue; // ignore this result
		  }

		  // nick "file name" md5 size bitrate frequency time

		  String filename = tokenizer.nextToken();
		  filename = tokenizer.nextToken();  // we should have the filename now
		  
		  String right = tokenizer.nextToken();
		  StringTokenizer tokenizer_inner = new StringTokenizer(right," ");

		  if (tokenizer_inner.countTokens() != 5) {
//			GUI.status.changeStatus("Got weird search result - aborting (if there are no results just search again)");
//			return;
			System.out.println("Got broken package --> read over it");
			continue; // ignore this result
		  }

		  StringTokenizer tokenizer_fn = new StringTokenizer(filename,"\\");
		  while (tokenizer_fn.hasMoreTokens()) {
		    filename_short = tokenizer_fn.nextToken();
		  }

		  String md5 = tokenizer_inner.nextToken();
		  String size = tokenizer_inner.nextToken();
		  String bitrate = tokenizer_inner.nextToken();
		  String frequency = tokenizer_inner.nextToken();

		  String length = lengthtext;  // values are from calling class
		  String nick = text;

		  String ip = iptext;

		  String link = linktext;

		  GUI.content.updateSearchContent(row, filename_short, size, bitrate, frequency, length, nick, ip, link, filename, ":-?");

//		  Main.comm.recPacket(212, 11);
  		}

		GUI.status.changeStatus("Browsing finished");

	  }
	};

	t.start();

  }
  
}



