/*
 * +-----------------------------------------------+
 * | System:                                       |
 * | Package:                                      |
 * | Class:    Comm                                |
 * +-----------------------------------------------+
 * | Author:   Michael Ransburg (Daneel)           |
 * |           <daneel@tux.org>                    |
 * | Created:  04.12.1999                          |
 * | Version:  0.0.1                               |
 * +-----------------------------------------------+
 *
 * Changes:
 *     04.12.1999 - (Daneel): - created :-)
 *
 */

import java.util.*;
import java.io.*;
import java.net.*;
import java.lang.*;

public class Checkhost {

  public Checkhost(final String nick, final String file, final String file_short, final String speed, final String filesize, final int rowindex) {
		
	String respone = new String();
	String temp = new String();
	String ip = new String();
	int port = -1;
	String request = nick + " \"" + file + "\"";
		
	InputStream inputstream;
	OutputStream outputstream;

	System.out.println("\n\n");
	System.out.println("RowID: " + rowindex);
	System.out.println("Request: " + request);
	System.out.println("file");
		

	GUI.status.changeStatus("Checking " + file_short);

	
	String response = new String();
	int counter = 0;

	do { // sometimes we get wrong server responses - catch this

	
	  Main.comm.sendPacket(203, request);
	  try {
		java.lang.Thread.sleep(1000);
	  }
	  catch (InterruptedException ie) {
		System.out.println("ERROR - could not sleep");
		return;
	  }

	  Main.comm.recPacket(204, 30);

	  if (Main.comm.getMessid() != 10) {
		response = Main.comm.getContent();
	  }
	  else {
		GUI.content.changeAvailabilitySearchContent(rowindex, "messid != 10!");
		System.out.println("ERROR - no return message with ID 10");
		return;
	  }

	  StringTokenizer filetokenizer = new StringTokenizer(response, "\"");  // should be 3

	  System.out.println("Checkhost Token 1: " + filetokenizer.countTokens());


	  if (filetokenizer.countTokens() != 3) {
		GUI.content.changeAvailabilitySearchContent(rowindex, "Server gave wrong response");
		return;
	  }


	  temp = filetokenizer.nextToken();
	  temp = filetokenizer.nextToken();
	  System.out.println("FFF2: " + temp);
	  System.out.println("FFF2: " + file);
	  System.out.println(temp.compareTo(file));

	  counter++;
	  
	  if (counter == 10) {
		GUI.content.changeAvailabilitySearchContent(rowindex, "Server gave wrong response");
		return;
	  }

	} while (temp.compareTo(file) != 0);



	StringTokenizer tokenizer = new StringTokenizer(response," ");

	System.out.println("Server response: " + response);
	
	temp = tokenizer.nextToken();		

	System.out.println("temp: " + temp);

	int iptemp = (int)Long.parseLong(tokenizer.nextToken());
	Integer porttemp = new Integer(tokenizer.nextToken().trim());
	port = porttemp.intValue();
		
	// convert ip to something more readable. stolen from the jnapster client of Harikrishnan Varma, thnx buddy :)
	StringBuffer s = new StringBuffer();
	
	s.append(String.valueOf(iptemp & 0xFF) + ".");
	s.append(String.valueOf((iptemp >> 8)  & 0xFF) + ".");
	s.append(String.valueOf((iptemp >> 16) & 0xFF) + ".");
	s.append(String.valueOf((iptemp >> 24) & 0xFF));

	ip = s.toString();


	if (port == 0) { // other client behind firewall

	  GUI.content.changeAvailabilitySearchContent(rowindex, "behind firewall");
	  System.out.println("ERROR - other client is behind firewall");
	  return;
			
	}

	Socket socket;

	try {
	  socket = new Socket(ip, port);
	}
	catch (UnknownHostException uh) {
	  GUI.content.changeAvailabilitySearchContent(rowindex, "Unknown Host");
	  System.out.println("ERROR - unknown host");
	  return;
	}
	catch (IOException io) {
	  GUI.content.changeAvailabilitySearchContent(rowindex, "Could not create socket");
	  System.out.println("ERROR - could not create socket");
	  return;
	}


	try {	  
	  outputstream = socket.getOutputStream();		
	}
	catch (IOException io) {
	  GUI.content.changeAvailabilitySearchContent(rowindex, "Could not get Outputstream");
	  System.out.println("ERROR - could not get outputstream");
	  return;
	}
	
	try {
	  inputstream = socket.getInputStream();
	}
	catch (IOException io) {
	  GUI.content.changeAvailabilitySearchContent(rowindex, "Could not get Inputstream");
	  System.out.println("ERROR - could not get inputstream");
	  return;
	}

	// read magic number '1'		  
	try {
	  char c = (char) inputstream.read();
	}
	catch (IOException io) {
	  GUI.content.changeAvailabilitySearchContent(rowindex, "Could not read magic number 1");
	  System.out.println("ERROR - could not read magic byte (= first byte)");
	  return;
	}


	// get request needs to be split over 2 packets
	String message = "GET";

	try {
	  outputstream.write(message.getBytes());
	  outputstream.flush();
	}
	catch (IOException io) {
	  GUI.content.changeAvailabilitySearchContent(rowindex, "Could not write GET message");
	  System.out.println("ERROR - could not send GET message");
	  return;
	}

	message = Main.comm.getUserName() + " " + "\"" + file + "\"" + " " + "0";

	System.out.println("GET " + message);

	try {
	  outputstream.write(message.getBytes());
	  outputstream.flush();
	}
	catch (IOException io) {
	  GUI.content.changeAvailabilitySearchContent(rowindex, "Could not send \"username file\" request");
	  System.out.println("ERROR - could not send second part of GET message");
	  return;
	}


	// don't ask...
	byte[] data = new byte[2048];
	String file_len = null;
		  
	// 255 is the first byte of the mp3. stuff between contains size and stuff
	int b = 0;
		  
	// String data
	String content;

	try {

	  b = inputstream.read(data);		  
	  content = new String(data).trim();
		
	  System.out.println(content + "\n");

	  if (content.compareTo("FILE NOT SHARED") == 0) {
		GUI.content.changeAvailabilitySearchContent(rowindex, "File not shared");
		socket.close();
		return;
	  }
		
	  if (content.compareTo("INVALID REQUEST") == 0) {
		GUI.content.changeAvailabilitySearchContent(rowindex, "INVALID REQUEST");
		socket.close();
		return;
	  }
	  
	}
	  
	catch (IOException io) {
	  GUI.content.changeAvailabilitySearchContent(rowindex, "Could not read file data");
	  System.out.println(io);
	  return;
	}

 	GUI.content.changeAvailabilitySearchContent(rowindex, ":-)");
	System.out.println("File available");

	try {
	  socket.close();
	}
	
	catch (IOException io) {
	  GUI.content.changeAvailabilitySearchContent(rowindex, "Could not close socket");
	  System.out.println(io);
	  return;
	}
  }

}



