/*
 * +-----------------------------------------------+
 * | System:                                       |
 * | Package:                                      |
 * | Class:    Comm                                |
 * +-----------------------------------------------+
 * | Author:   Michael Ransburg (Daneel)           |
 * |           <daneel@tux.org>                    |
 * | Created:  04.12.1999                          |
 * | Version:  0.0.1                               |
 * +-----------------------------------------------+
 *
 * Changes:
 *     04.12.1999 - (Daneel): - created :-)
 *
 */

import java.util.*;
import java.io.*;
import java.net.*;
import java.lang.*;

public class Download {

  private static Vector threadVector = new Vector();
  private int rowindex;

  public Download(final String nick, final String file, final String file_short, final String speed, final String filesize) {
	final Thread t = new Thread() {
	  public void run() {
		

		String respone = new String();
		String temp = new String();
		String ip = new String();
		int port = -1;
		String request = nick + " \"" + file + "\"";
		
		InputStream inputstream;
		OutputStream outputstream;

		rowindex = GUI.content.addRowTransferContent(file_short, filesize, nick, "downloading...", speed, "not yet", "not yet", "not yet");		

		GUI.status.changeStatus("Downloading " + file_short);

		String response = new String();
		int counter = 0;
	

		do {

		  Main.comm.sendPacket(203, request);
		  try {
			java.lang.Thread.sleep(500);
		  }
		  catch (InterruptedException ie) {
			System.out.println(ie);
		  }

		  Main.comm.recPacket(204, 30);

		  if (Main.comm.getMessid() != 10) {
			response = Main.comm.getContent();
		  }
		  else {
			GUI.content.changeStatusTransferContent(rowindex, "messid != 10!");
			System.out.println("File not available");
			return;
		  }

		  StringTokenizer filetokenizer = new StringTokenizer(response, "\"");
		  temp = filetokenizer.nextToken();
		  temp = filetokenizer.nextToken();
		  System.out.println("FFF2: " + temp);
		  System.out.println("FFF2: " + file);
		  System.out.println(temp.compareTo(file));

		  counter++;
	  
		  if (counter == 10) {
			GUI.content.changeAvailabilitySearchContent(rowindex, "Server gave wrong response");
			return;
		  }

		} while (temp.compareTo(file) != 0);


		StringTokenizer tokenizer = new StringTokenizer(response," ");
  
  
		System.out.println("\n\n\n" + response);
	
		temp = tokenizer.nextToken();		

		int iptemp = (int)Long.parseLong(tokenizer.nextToken());
		Integer porttemp = new Integer(tokenizer.nextToken().trim());
		port = porttemp.intValue();
		
		// convert ip to something more readable. stolen from the jnapster client of Harikrishnan Varma, thnx buddy :)
		StringBuffer s = new StringBuffer();
	
		s.append(String.valueOf(iptemp & 0xFF) + ".");
		s.append(String.valueOf((iptemp >> 8)  & 0xFF) + ".");
		s.append(String.valueOf((iptemp >> 16) & 0xFF) + ".");
		s.append(String.valueOf((iptemp >> 24) & 0xFF));

		ip = s.toString();


		if (port == 0) { // other client behind firewall

		  GUI.content.changeStatusTransferContent(rowindex, "behind firewall");
		  System.out.println("File not available port 0");
		  return;
			
		}

		Socket socket;

		try {
		  socket = new Socket(ip, port);
		}
		catch (UnknownHostException uh) {
		  GUI.content.changeStatusTransferContent(rowindex, "Unknown Host");
		  return;
		}
		catch (IOException io) {
		  GUI.content.changeStatusTransferContent(rowindex, "Could not create socket");
		  return;
		}


		try {	  
		  outputstream = socket.getOutputStream();		
		}
		catch (IOException io) {
		  GUI.content.changeStatusTransferContent(rowindex, "Could not get Outputstream");
		  return;
		}
	
		try {
		  inputstream = socket.getInputStream();
		}
		catch (IOException io) {
		  GUI.content.changeStatusTransferContent(rowindex, "Could not get Inputstream");
		  return;
		}

		// read magic number '1'		  
		try {
		  char c = (char) inputstream.read();
		}
		catch (IOException io) {
		  GUI.content.changeStatusTransferContent(rowindex, "Could not read magic number 1");
		  return;
		}


		// get request needs to be split over 2 packets
		String message = "GET";

		try {
		  outputstream.write(message.getBytes());
		  outputstream.flush();
		}
		catch (IOException io) {
		  GUI.content.changeStatusTransferContent(rowindex, "Could not write GET message");
		  return;
		}

		message = Main.comm.getUserName() + " " + "\"" + file + "\"" + " " + "0";

		try {
		  outputstream.write(message.getBytes());
		  outputstream.flush();
		}
		catch (IOException io) {
		  GUI.content.changeStatusTransferContent(rowindex, "Could not send \"username file\" request");
		  return;
		}



		// don't ask...
		byte[] data = new byte[2048];
		byte[] bytecontent = new byte[2048];
		String file_len = null;
		  
		// 255 is the first byte of the mp3. stuff between contains size and stuff
		int b = 0;
		  
		// String data
		String content;

		System.out.println("E1");

		for (int i = 0; i < 2048; i++) {

		  try {
//			b = inputstream.read(bytecontent);
			b = inputstream.read();
		  }
		  catch (IOException io) {
			GUI.content.changeStatusTransferContent(rowindex, "Could not read File Data");
			return;
		  }

/*
		  content = new String(bytecontent);

		  if (content.compareTo("FILE NOT SHARED") == 0) {
			GUI.content.changeStatusTransferContent(rowindex, "File not shared");
			return;
		  }
		
		  if (content.compareTo("INVALID REQUEST") == 0) {
			GUI.content.changeStatusTransferContent(rowindex, "INVALID REQUEST");
			return;
		  }


		  System.out.println("B: " + content);
*/

		  System.out.println(b);

		  data[i] = (byte) b;

		  if (b == 255) {
			file_len = new String(data, 0, i);
			break;
		  }
			
		  data[i] = (byte) b;
		}


		System.out.println("E2 " + file_len.trim());

		long file_size = Long.parseLong(file_len.trim());
		
		FileOutputStream fileoutputstream;

		try {
		  fileoutputstream = new FileOutputStream(file_short);
		}
		catch (FileNotFoundException fnf) {
		  GUI.content.changeStatusTransferContent(rowindex, "Could not open File");
		  return;
		}
		catch (IOException io) {
		  System.out.println(io);
		  return;
		}
		  
		// the first bye (255) has already been read
		try {
		  fileoutputstream.write((byte)255);
		}
		catch (IOException io) {
		  GUI.content.changeStatusTransferContent(rowindex, "Could not write to File");
		  return;
		}

		long bytes_transfered = 1;
		int bytes_read = 0;

		System.out.println("E3");
		  
		do {

		  try {
			bytes_read = inputstream.read(data);
		  }
		  catch (IOException io) {
			if (bytes_transfered > (file_size * 3 / 4)) {
			  GUI.content.changeStatusTransferContent(rowindex, "Finished");
			  return;
			}
			else {
			  GUI.content.changeStatusTransferContent(rowindex, "Could not read from Socket");
			  return;
			}
		  }
			
		  if (bytes_read == -1) {
			break;
		  }
	
		  bytes_transfered += bytes_read;

		  GUI.content.changeProgressTransferContent(rowindex, bytes_transfered);

//		  System.out.println("E4");

		  try {
			fileoutputstream.write(data, 0, bytes_read);
		  }
		  catch (IOException io) {
			GUI.content.changeStatusTransferContent(rowindex, "Could not write to File");
			return;
		  }
		  GUI.content.changeProgressTransferContent(rowindex, bytes_transfered);


		} while (bytes_transfered < file_size);


		System.out.println("E5");


		try {
		  inputstream.close();
		  fileoutputstream.flush();
		  fileoutputstream.close();
		}
		catch (IOException io) {
		  GUI.content.changeStatusTransferContent(rowindex, "Could not close descriptors");
		  return;
		}

		GUI.status.changeStatus("Download of " + file_short + " finished.");
		GUI.content.changeStatusTransferContent(rowindex, "finished");


	  }
	};

	t.start();

	// get sure the rowindex is initialized
	try {
	  java.lang.Thread.sleep(1000);
	}
	catch (InterruptedException ie) {
	  System.out.println(ie);
	}

	// add Thread to Vector (need that if someone wants to abort a transfer)
	threadVector.insertElementAt(t, rowindex);
	System.out.println("RowIndex1: " + rowindex);

  }

  
  public static Thread getThread(int index) {
	return (Thread)threadVector.elementAt(index);  
  }

}



