/**
 *
 * @author Michael Ransburg
 * @version 0.01
 */

import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.lang.*;
import java.net.*;

public class Feedback {

  private JTextField jtName;
  private JTextField jtEmail;
  private JTextArea jtaText;
  private final JFrame frame;

  public Feedback() {
  
	frame = new JFrame();
	JEditorPane jeFeedback;

	/* close app if someone clicks on X */
	frame.addWindowListener (new java.awt.event.WindowAdapter () {
      public void windowClosing (java.awt.event.WindowEvent evt) {
  	    frame.dispose();
      }
    }
    );

	frame.setTitle("Send Feedback");

	frame.setBounds(250,140,800,800);

	frame.getContentPane().setLayout(new BorderLayout());
	frame.getContentPane().setBackground(java.awt.Color.black);  


	JTextArea jtaFeedback = new JTextArea();
    jtaFeedback.setLineWrap(true);
	jtaFeedback.setWrapStyleWord(true);
  	jtaFeedback.setCaretColor (java.awt.Color.red);
  	jtaFeedback.setPreferredSize (new java.awt.Dimension(340, 160));
  	jtaFeedback.setBackground (java.awt.Color.black);
  	jtaFeedback.setForeground (java.awt.Color.red);
  	jtaFeedback.setEditable (false);
  	jtaFeedback.setSelectedTextColor (java.awt.Color.red);
	jtaFeedback.setFont(new Font("Monospaced", 0, 12));
	jtaFeedback.setMargin(new java.awt.Insets(10,10,10,10));

	jtaFeedback.append("Feedback is very important and very valuable to me. Please take some seconds and send me suggestions, critism, questions or everything else you think is important.\n\n");
	jtaFeedback.append("Please don't forget to include your name and email address if you would like to get a reply! :)\n\n");

	frame.getContentPane().add(jtaFeedback, "North");



	// add the textarea
	jtaText = new JTextArea();
    jtaText.setLineWrap(true);
	jtaText.setWrapStyleWord(true);
  	jtaText.setCaretColor (java.awt.Color.black);
	jtaText.setRows(300);
  	jtaText.setBackground (java.awt.Color.white);
  	jtaText.setForeground (java.awt.Color.black);
  	jtaText.setEditable (true);
  	jtaText.setSelectedTextColor (java.awt.Color.black);
	jtaText.setFont(new Font("Monospaced", 0, 10));
	jtaText.setMargin(new java.awt.Insets(3,3,3,3));

	JPanel jpText = new JPanel();
	jpText.setBackground(java.awt.Color.black);

	JScrollPane jsText = new JScrollPane(jtaText);
	jsText.setPreferredSize(new java.awt.Dimension(300, 200));

	jpText.add(jsText);

	frame.getContentPane().add(jpText, "Center");
	

	// add name and email field. jpanel --> jpanelemail --> flowlayout --> textfield
	//                                  --> jpanelname  --> flowlayout --> textfield
	//                                  --> jpSubmit    --> flowlayout --> jbutton
	
	JPanel jpTextfields = new JPanel();
	jpTextfields.setLayout(new BorderLayout());
	
	
	JPanel jpName = new JPanel();
	jpName.setLayout(new FlowLayout(java.awt.FlowLayout.LEFT));
	jpName.setBackground(java.awt.Color.black);

	JLabel jlName = new JLabel("Your Name: ");
	jlName.setForeground(java.awt.Color.white);
	jlName.setHorizontalAlignment(SwingConstants.RIGHT);
	jpName.add(jlName);

	jtName = new JTextField(14);
	jpName.add(jtName);
	jpTextfields.add(jpName, "North");
	
	
	
	JPanel jpEmail = new JPanel();
	jpEmail.setLayout(new FlowLayout(java.awt.FlowLayout.LEFT));
	jpEmail.setBackground(java.awt.Color.black);
	
	JLabel jlEmail = new JLabel("Your Email: ");
	jlEmail.setForeground(java.awt.Color.white);
	jlEmail.setHorizontalAlignment(SwingConstants.RIGHT);
	jpEmail.add(jlEmail);
	
	jtEmail = new JTextField(14);
	jpEmail.add(jtEmail);
	jpTextfields.add(jpEmail, "Center");
	
	
	
	JPanel jpSubmit = new JPanel();
	jpSubmit.setLayout(new FlowLayout(java.awt.FlowLayout.CENTER));
	jpSubmit.setBackground(java.awt.Color.black);
	
	JButton jbSubmit = new JButton("  Submit  ");
    jbSubmit.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
		submit();
      }
    }
    );	
	jpSubmit.add(jbSubmit, "South");
	jpTextfields.add(jpSubmit, "South");
	
	
	frame.getContentPane().add(jpTextfields, "South");


	frame.pack();
	frame.show();

  }

  public void submit() {

	String namestring = jtName.getText().trim();
	String emailstring = jtEmail.getText().trim();
	String messagestring = jtaText.getText().trim();
	
	namestring = URLEncoder.encode(namestring);
	emailstring = URLEncoder.encode(emailstring);
	messagestring = URLEncoder.encode(messagestring);
	
	String url = "http://www.tux.org/~daneel/cgi-bin/getmail.pl?from=" + emailstring + "&name=" + namestring + "&message=" + messagestring;

	try {
	  URL myurl = new URL(url);
	  myurl.getContent();
	}
	catch(MalformedURLException mu) {
	  System.out.println(mu);
	}
	catch(IOException io) {
	  System.out.println(io);
	}


	GUI.status.changeStatus("Feedback has been sent - thank you VERY much!");
	frame.dispose();
	
/*
	System.out.println(namestring);
	System.out.println(emailstring);
	System.out.println(messagestring);
*/
  
  }

}

