/**
 *
 * @author Michael Ransburg
 * @version 0.01
 */

import javax.swing.*;
import java.awt.*;
import java.lang.*;
import java.io.*;
import java.util.*;

public class Host {

  public Host() {
  
  }

  public boolean exists(String hostname) { // returns true / false if hostname exists / does not exist
	File hostfile = new File("hosts");
	
	if (hostfile.exists()) {
	  try {
		BufferedReader hostreader = new BufferedReader(new InputStreamReader(new FileInputStream("hosts")));

		for ( ;; ) {
		  if (hostreader.ready()) {
			if (hostname.compareTo(hostreader.readLine()) == 0) { // this host is already in the list
			  return true;
			}
		  }
		  else { // we searched through the file, host is not in the list
			return false;
		  }
		}
	  }	
	  catch(FileNotFoundException fnf) {
		System.out.println(fnf);
	  }
	  catch(IOException io) {
		System.out.println(io);
	  }
	}
	
	return false; // file does not exist --> host cannot be known
		
  }

  public void add(String hostname) { // adds a host to the hosts file
	File hostfile = new File("hosts");

	System.out.println("file exists: " + hostfile.exists());
	System.out.println("hostname   : " + hostname);
	  
	try {
	  if (hostfile.exists()) {
		PrintWriter hostwriter = new PrintWriter(new FileWriter("hosts", true));
		hostwriter.println(hostname);
		hostwriter.flush();
		hostwriter.close();
	  }

	  else {
		PrintWriter hostwriter = new PrintWriter(new FileWriter("hosts", false));
		hostwriter.println(hostname);
		hostwriter.flush();
		hostwriter.close();
	  }
	}
	catch(FileNotFoundException fnf) {
	  System.out.println(fnf);
	}
	catch(IOException io) {
	  System.out.println(io);
	}

  }
  
  public Vector returnList() { // returns a vector of all known hostnames
	Vector contents = new Vector();
	File hostfile = new File("hosts");
	String thisLine;

	if (hostfile.exists()) {
	  try {
		BufferedReader hostreader = new BufferedReader(new InputStreamReader(new FileInputStream("hosts")));

		while ((thisLine = hostreader.readLine()) != null) { // if line == NULL, file is finished
		  if (thisLine.length() > 0) { // make sure we have something here
			contents.addElement(thisLine);
		  }
		}

	  }	
	  catch(FileNotFoundException fnf) {
		System.out.println(fnf);
	  }
	  catch(IOException io) {
		System.out.println(io);
	  }
	}
	
	return contents; // return the vector
		
  }
  
}

