/**
 *
 * @author Michael Ransburg
 * @version 0.01
 */

import javax.swing.*;
import java.awt.*;
import java.lang.*;
import java.net.*;
import java.util.*;

public class LoginDialog {

  public LoginDialog() {
  
	final JFrame frame = new JFrame();

	// change status bar
	GUI.status.changeStatus("Login process...");

	/* close app if someone clicks on X */
	frame.addWindowListener (new java.awt.event.WindowAdapter () {
      public void windowClosing (java.awt.event.WindowEvent evt) {
  	    frame.dispose();
      }
    }
    );



	frame.setTitle("Login Dialog");

	frame.setBounds(250,200,800,800);

	frame.getContentPane().setLayout(new BorderLayout());
	frame.getContentPane().setBackground(java.awt.Color.black);  

    JPanel jpLogin = new JPanel();
	jpLogin.setBackground(java.awt.Color.black);
	jpLogin.setLayout(new java.awt.GridLayout(11,2)); // change here if you are adding fields


	JLabel temp1 = new JLabel();
	temp1.setText(" ");
	jpLogin.add(temp1);
	
	JLabel temp2 = new JLabel();
	temp2.setText(" ");
	jpLogin.add(temp2);


	
	JLabel jlNewuser = new JLabel();
	jlNewuser.setText("New User?");
	jlNewuser.setForeground(java.awt.Color.white);
	jpLogin.add(jlNewuser);
	
	final JCheckBox jcNewuser = new JCheckBox();
	jpLogin.add(jcNewuser);
	

	JLabel jlUsername = new JLabel();
	jlUsername.setPreferredSize(new java.awt.Dimension(30,20));
	jlUsername.setText("Username");
	jlUsername.setForeground(java.awt.Color.white);
	jpLogin.add(jlUsername);

	final JTextField jteUsername = new JTextField(20);
	jpLogin.add(jteUsername);  

	
  
	JLabel jlPassword = new JLabel();
	jlPassword.setPreferredSize(new java.awt.Dimension(30,20));
	jlPassword.setText("Password");
	jlPassword.setForeground(java.awt.Color.white);
	jpLogin.add(jlPassword);
	
	final JPasswordField jtePassword = new JPasswordField(20);
	jpLogin.add(jtePassword);  
	


	JLabel jlPort = new JLabel();
	jlPort.setText("Local Port");
	jlPort.setPreferredSize(new java.awt.Dimension(30,20));	
	jlPort.setForeground(java.awt.Color.white);
	jpLogin.add(jlPort);

	final JTextField jtePort = new JTextField(20);
	jtePort.setText("6699");
	jpLogin.add(jtePort);  
	
	

	JLabel jlClient = new JLabel();
	jlClient.setText("Client Info");
	jlClient.setPreferredSize(new java.awt.Dimension(30,20));
	jlClient.setForeground(java.awt.Color.white);
	jpLogin.add(jlClient);

	final JTextField jteClient = new JTextField(20);
	jteClient.setText("nap v0.8");
	jpLogin.add(jteClient);  


	Object[] items = {"unknown", "14.4 kbps", "28.8 kbps", "33.6 kbps", "56.7 kbps", "64K ISDN", "128K ISDN", "Cable", "DSL", "T1", "T3 or greater"};

	JLabel jlLink = new JLabel();
	jlLink.setText("Link Type");
	jlLink.setPreferredSize(new java.awt.Dimension(30,20));
	jlLink.setForeground(java.awt.Color.white);
	jpLogin.add(jlLink);
	
	final JComboBox jcLink = new JComboBox(items);
	jpLogin.add(jcLink);  



	JLabel jlRemotehost = new JLabel();
	jlRemotehost.setText("Remote Host");
	jlRemotehost.setPreferredSize(new java.awt.Dimension(30,20));
	jlRemotehost.setForeground(java.awt.Color.white);
	jpLogin.add(jlRemotehost);

	
	final JTextField jteRemotehost = new JTextField(20);
	
	// resolve remote host name
	try {
	  InetAddress reminet = InetAddress.getByName("server.napster.com");
	  jteRemotehost.setText(reminet.getHostAddress());
	}
	catch(UnknownHostException uh) {
	  jteRemotehost.setText("could not resolve server.napster.com");
	}
	
//	jteRemotehost.setText(reminet.getHostName());
	jpLogin.add(jteRemotehost);  



	JLabel jlRemoteport = new JLabel();
	jlRemoteport.setText("Remote Port");
	jlRemoteport.setPreferredSize(new java.awt.Dimension(30,20));
	jlRemoteport.setForeground(java.awt.Color.white);
	jpLogin.add(jlRemoteport);
	
	final JTextField jteRemoteport = new JTextField(20);
	jteRemoteport.setText("8875");
	jpLogin.add(jteRemoteport);  



	// file server
	JLabel jlFileserver = new JLabel();
	jlFileserver.setText("File Server");
	jlFileserver.setPreferredSize(new java.awt.Dimension(30,20));
	jlFileserver.setForeground(java.awt.Color.white);
	jpLogin.add(jlFileserver);
	
	Vector tempVec = Main.host.returnList();
	tempVec.insertElementAt((Object)"random", 0);
	final JComboBox jcFile = new JComboBox(tempVec);
	jpLogin.add(jcFile);  



	JLabel temp3 = new JLabel();
	temp3.setText(" ");
	jpLogin.add(temp3);
	
	JLabel temp4 = new JLabel();
	temp4.setText(" ");
	jpLogin.add(temp4);


//  public void Login(String username, String password, String port, String clientinfo, String linktype, String remotehost, int remoteport) {
	

    JPanel jpLogin2 = new JPanel ();
	jpLogin2.setBackground(java.awt.Color.black);
    jpLogin2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER));

	JButton jbLogin = new JButton("  Login  ");
    jbLogin.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {

		String content;
//		int newuser = 0;

		// get text
		final String username = jteUsername.getText().trim();
		final String password = jtePassword.getText().trim();
		final String port = jtePort.getText().trim();
		final String clientinfo = jteClient.getText().trim();
		final String linktype = String.valueOf(jcLink.getSelectedIndex());
		final String remotehost = jteRemotehost.getText().trim();
		final int remoteport = new Integer(jteRemoteport.getText().trim()).intValue();

		System.out.println(jcNewuser.isSelected());


		GUI.content.showTextArea();				

		frame.dispose();

		final Thread u = new Thread() {
		  public void run() {

			int newuser = 0;             // we cannot do that outsite this thread, because it can't be final
			String filehost = new String();						

			if (jcNewuser.isSelected()) {
			  newuser = 1;
			}

			if (jcFile.getSelectedIndex() == 0) { // get random server
			  filehost = Main.comm.LoginDistribution(remotehost, remoteport);
			  filehost = filehost.trim();
			  
			  if (!Main.host.exists(filehost)) { // if file host is not in list add it
				Main.host.add(filehost);				
			  }
			}
			else { // connect directly to server
			  filehost = (String)jcFile.getSelectedItem();
			  filehost = filehost.trim();
			}
			  
			Main.comm.LoginFileServer(filehost, newuser, username, password, port, clientinfo, linktype);

		  }
		};

		u.start();
			

/*
		while (!Main.comm.vecContent.isEmpty()) {
		  content = (String)Main.comm.vecContent.firstElement();
		  
		  GUI.content.appendcontent("                 ");
		  GUI.content.appendcontent(content);

		  Main.comm.vecContent.removeElement(Main.comm.vecContent.firstElement());

		}
*/


//		frame.dispose();
      }
    }
    );

	jpLogin2.add(jbLogin);

	frame.getContentPane().add(jpLogin2, "South");
	frame.getContentPane().add(jpLogin, "Center");

	frame.pack();
	frame.show();

  }
}

