/*
 * +-----------------------------------------------+
 * | System:                                       |
 * | Package:                                      |
 * | Class:    Comm                                |
 * +-----------------------------------------------+
 * | Author:   Michael Ransburg (Daneel)           |
 * |           <daneel@tux.org>                    |
 * | Created:  04.12.1999                          |
 * | Version:  0.0.1                               |
 * +-----------------------------------------------+
 *
 * Changes:
 *     04.12.1999 - (Daneel): - created :-)
 *
 */

import java.util.*;
import java.io.*;
import java.net.*;

public class Search {

  public Search(final String text) {
	Thread t = new Thread() {
	  public void run() {

		String response;
		String filename_short = new String();
		String responsestring = new String();
		String searchtext = "MAX_RESULTS 100 FILENAME CONTAINS \"" + text + "\"";
		int row = 0;

		
		GUI.status.changeStatus("Searching ... please wait");
		GUI.content.clearSearchContent();
  
		// clear the buffer
//		while (Main.comm.getMessid() != -10) {
//		  Main.comm.recPacket(201, 11);
//		}

		Main.comm.sendPacket(200, searchtext);

		try {
		  java.lang.Thread.sleep(3000);
		}
		catch (InterruptedException ie) {
		  System.out.println(ie);
		}

//		Main.comm.recPacket(201, 11);
//		Main.comm.recPacket();
		

//		while (Main.comm.getMessid() != -10) {

		for ( ;; ) {

		  Main.comm.recPacket();

		  if (Main.comm.getMessid() == 202) { // 0 byte data section --> finished
			System.out.println("Got 0 byte packet --> search finished");
			break;
		  }

		  if (Main.comm.getMessid() != 201) { // read over status packages
			System.out.println("Got status packet --> read over it");
			continue;
		  }

		  response = Main.comm.getContent();

		  StringTokenizer tokenizer = new StringTokenizer(response,"\"");
	  
		  if (tokenizer.countTokens() != 2) {
//			GUI.status.changeStatus("Got weird search result - aborting (if there are no results, just search again)");
//			System.out.println("Invalid Token Counter: " + response);
//			return;
			System.out.println("Got broken package --> read over it");
			continue; // ignore this result
		  }

		  String filename = tokenizer.nextToken();
		  String right = tokenizer.nextToken();
		  StringTokenizer tokenizer_inner = new StringTokenizer(right," ");

		  if (tokenizer_inner.countTokens() != 8) {
//			GUI.status.changeStatus("Got weird search result - aborting (if there are no results just search again)");
//			System.out.println("Invalid Token Counter: " + right);
//			return;
			System.out.println("Got broken package --> read over it");
			continue; // ignore this result
		  }

		  StringTokenizer tokenizer_left = new StringTokenizer(filename,"\\");
		  while (tokenizer_left.hasMoreTokens()) {
			filename_short = tokenizer_left.nextToken();
		  }

		  String md5 = tokenizer_inner.nextToken();
		  String size = tokenizer_inner.nextToken();
		  String bitrate = tokenizer_inner.nextToken();
		  String frequency = tokenizer_inner.nextToken();
		  String length = tokenizer_inner.nextToken();
		  String nick = tokenizer_inner.nextToken();
		  int iptemp = (int)Long.parseLong(tokenizer_inner.nextToken());


		  // convert ip to something more readable. stolen from the jnapster client of Harikrishnan Varma, thnx buddy :)
		  StringBuffer s = new StringBuffer();
	
		  s.append(String.valueOf(iptemp & 0xFF) + ".");
		  s.append(String.valueOf((iptemp >> 8)  & 0xFF) + ".");
		  s.append(String.valueOf((iptemp >> 16) & 0xFF) + ".");
		  s.append(String.valueOf((iptemp >> 24) & 0xFF));

		  String ip = s.toString();

		  String link = tokenizer_inner.nextToken().trim();
		  int linkvalue = new Integer(link).intValue();
		  
		  switch (linkvalue) {
		    case 0:
		  	  link = "unknown";
			  break;
			case 1:
			  link = "14.4 kbps";
			  break;
			case 2:
			  link = "28.8 kbps";
			  break;
			case 3:
			  link = "33.6 kbps";
			  break;
			case 4:
			  link = "56.7 kbps";
			  break;
			case 5:
			  link = "64k ISDN";
			  break;
			case 6:
			  link = "128K ISDN";
			  break;
			case 7:
			  link = "Cable";
			  break;
			case 8:
  			  link = "DSL";
			  break;
			case 9:
			  link = "T1";
			  break;
			case 10:
			  link = "T3 or greater";
			  break;
			default:
			  link = "unknown";
			  break;
		  }

		  GUI.content.updateSearchContent(row, filename_short, size, bitrate, frequency, length, nick, ip, link, filename, ":-?");

//		  Main.comm.recPacket();
//		  Main.comm.recPacket(201, 11);
  		}

		GUI.status.changeStatus("Search finished");

	  }
	};

//	t.setPriority(1);
	t.start();

  }
  
}



